%Create MLS and MLS_PINK noise.  Writes a series of WAV files.

fs=44100;
for M=13:16,
[mls]=make_sig_mls_helper(M,fs);
N=length(mls);
fn=sprintf('sig_mls_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls, mls], fs);

% Make Pink Noise.  Divide each Fourier amplitude a_k by sqrt(k), where
% k is wave number.
MLS=fft(mls);
Nby2=floor(N/2);
fidx=(1:Nby2); % wave number indices
f=fidx/N*fs;
kidx=transpose(1:Nby2);
sqr_kidx=sqrt(kidx);
MLS(1+kidx)=MLS(1+kidx)./sqr_kidx;
MLS(N+1-kidx)=MLS(N+1-kidx)./sqr_kidx;
mls_pink=real(ifft(MLS));  %mls_pink=ifft(MLS); % Should work!
mls_pink=mls_pink/max(abs(mls_pink)); % normalize

fn=sprintf('sig_mls_pink_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls_pink, mls_pink], fs);

end

fs=48000;
for M=13:16,
[mls]=make_sig_mls_helper(M,fs);
N=length(mls);
fn=sprintf('sig_mls_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls, mls], fs);


MLS=fft(mls);
Nby2=floor(N/2);
fidx=(1:Nby2); % wave number indices
f=fidx/N*fs;
kidx=transpose(1:Nby2);
sqr_kidx=sqrt(kidx);
MLS(1+kidx)=MLS(1+kidx)./sqr_kidx;
MLS(N+1-kidx)=MLS(N+1-kidx)./sqr_kidx;
mls_pink=real(ifft(MLS));  %mls_pink=ifft(MLS); % Should work!
mls_pink=mls_pink/max(abs(mls_pink)); % normalize

fn=sprintf('sig_mls_pink_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls_pink, mls_pink], fs);
end

fs=88200;
for M=13:16,
[mls]=make_sig_mls_helper(M,fs);
N=length(mls);
fn=sprintf('sig_mls_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls, mls], fs);

% Make Pink Noise.  Divide each Fourier amplitude a_k by sqrt(k), where
% k is wave number.
MLS=fft(mls);
Nby2=floor(N/2);
fidx=(1:Nby2); % wave number indices
f=fidx/N*fs;
kidx=transpose(1:Nby2);
sqr_kidx=sqrt(kidx);
MLS(1+kidx)=MLS(1+kidx)./sqr_kidx;
MLS(N+1-kidx)=MLS(N+1-kidx)./sqr_kidx;
mls_pink=real(ifft(MLS));  %mls_pink=ifft(MLS); % Should work!
mls_pink=mls_pink/max(abs(mls_pink)); % normalize

fn=sprintf('sig_mls_pink_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls_pink, mls_pink], fs);

end

fs=96000;
for M=13:16,
[mls]=make_sig_mls_helper(M,fs);
N=length(mls);
fn=sprintf('sig_mls_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls, mls], fs);


MLS=fft(mls);
Nby2=floor(N/2);
fidx=(1:Nby2); % wave number indices
f=fidx/N*fs;
kidx=transpose(1:Nby2);
sqr_kidx=sqrt(kidx);
MLS(1+kidx)=MLS(1+kidx)./sqr_kidx;
MLS(N+1-kidx)=MLS(N+1-kidx)./sqr_kidx;
mls_pink=real(ifft(MLS));  %mls_pink=ifft(MLS); % Should work!
mls_pink=mls_pink/max(abs(mls_pink)); % normalize

fn=sprintf('sig_mls_pink_%d_%dk.wav', N, floor(fs/1000))
audiowrite(fn,[mls_pink, mls_pink], fs);
end
